## kdevelop 5.6.2

=== kdevplatform/CMakeLists.txt ===
# kdevplatform soversion
# E.g. for KDevelop 5.2.0 => SOVERSION 52 (we only promise ABI compatibility between patch version updates)
set(KDEVPLATFORM_SOVERSION ${KDEVELOP_SOVERSION})

# Increase this to reset incompatible item-repositories.
# Changing KDEVELOP_VERSION automatically resets the itemrepository as well.
set(KDEV_ITEMREPOSITORY_INCREMENT 1)

set(KDevPlatform_SOURCE_DIR ${CMAKE_CURRENT_SOURCE_DIR})
set(KDevPlatform_BINARY_DIR ${CMAKE_CURRENT_BINARY_DIR})

set(CMAKE_MODULE_PATH ${KDevPlatform_SOURCE_DIR}/cmake/modules ${ECM_MODULE_PATH})
set(CMAKECONFIG_INSTALL_DIR "${KDE_INSTALL_CMAKEPACKAGEDIR}/KDevPlatform")

include(KDevPlatformMacros)
include(KDevPlatformMacrosInternal)

# have to set required in find_package call already
# as macros & imported targets are used later, so would fail over that before doing summary log
find_package(Grantlee5 CONFIG REQUIRED)
set_package_properties(Grantlee5 PROPERTIES
    PURPOSE "Grantlee templating library, needed for file templates"
    URL "http://www.grantlee.org/"
    TYPE REQUIRED)

set(Boost_ADDITIONAL_VERSIONS 1.39.0 1.39)
find_package(Boost 1.35.0)
set_package_properties(Boost PROPERTIES
    PURPOSE "Boost libraries for enabling the classbrowser"
    URL "https://www.boost.org/"
    TYPE REQUIRED)

configure_file( ${CMAKE_CURRENT_SOURCE_DIR}/config-kdevplatform.h.cmake
                ${CMAKE_CURRENT_BINARY_DIR}/config-kdevplatform.h )

include_directories(${KDevPlatform_SOURCE_DIR} ${KDevPlatform_BINARY_DIR})

if(BUILD_TESTING)
  set(KDEV_FIND_DEP_QT5TEST "find_dependency(Qt5Test \"${QT_MIN_VERSION}\")")
endif()
configure_package_config_file("${CMAKE_CURRENT_SOURCE_DIR}/KDevPlatformConfig.cmake.in"
                              "${CMAKE_CURRENT_BINARY_DIR}/KDevPlatformConfig.cmake"
                              INSTALL_DESTINATION  ${CMAKECONFIG_INSTALL_DIR}
)

ecm_setup_version(PROJECT
                  VARIABLE_PREFIX KDEVPLATFORM
                  VERSION_HEADER "${CMAKE_CURRENT_BINARY_DIR}/kdevplatform_version.h"
                  PACKAGE_VERSION_FILE "${CMAKE_CURRENT_BINARY_DIR}/KDevPlatformConfigVersion.cmake"
                  SOVERSION ${KDEVPLATFORM_SOVERSION}
)

add_subdirectory(sublime)
add_subdirectory(interfaces)
add_subdirectory(project)
add_subdirectory(language)
add_subdirectory(shell)
add_subdirectory(util)
add_subdirectory(outputview)
add_subdirectory(vcs)
add_subdirectory(pics)
add_subdirectory(debugger)
add_subdirectory(documentation)
add_subdirectory(serialization)
add_subdirectory(template)
if(BUILD_TESTING)
  add_subdirectory(tests)
endif()


install( FILES
        "${KDevPlatform_BINARY_DIR}/kdevplatform_version.h"
        "${KDevPlatform_BINARY_DIR}/config-kdevplatform.h"
        DESTINATION "${KDE_INSTALL_INCLUDEDIR}/kdevplatform" )
install( FILES
        "${KDevPlatform_BINARY_DIR}/KDevPlatformConfig.cmake"
        "${KDevPlatform_BINARY_DIR}/KDevPlatformConfigVersion.cmake"
        cmake/modules/KDevPlatformMacros.cmake
        DESTINATION "${CMAKECONFIG_INSTALL_DIR}" )
install( EXPORT KDevPlatformTargets
         DESTINATION "${CMAKECONFIG_INSTALL_DIR}"
         NAMESPACE KDev::
         FILE KDevPlatformTargets.cmake )

# kdebugsettings file
install_qt_logging_categories(TYPE LIBRARY)

=== plugins/CMakeLists.txt ===
# BEGIN: Analyzers
add_subdirectory(compileanalyzercommon)
add_subdirectory(clangtidy)
add_subdirectory(clazy)
add_subdirectory(cppcheck)
if(UNIX AND NOT (APPLE OR CYGWIN))
    add_subdirectory(heaptrack)
endif()
# END: Analyzers

# BEGIN: Debuggers
add_subdirectory(debuggercommon)
add_subdirectory(lldb)
add_subdirectory(gdb)
# END: Debuggers

# BEGIN: Documentation
find_package(Qt5Help CONFIG)
set_package_properties(Qt5Help PROPERTIES
    PURPOSE "The Help module for the Qt toolkit, needed for the qthelp plugin"
    URL "https://www.qt.io/"
    TYPE OPTIONAL)
if(Qt5Help_FOUND)
    ecm_optional_add_subdirectory(qthelp)
endif()
ecm_optional_add_subdirectory(manpage)
# END: Documentation

# BEGIN: Formatters
add_subdirectory(astyle)
add_subdirectory(customscript)
# END: Formatters

# BEGIN: Languages
ecm_optional_add_subdirectory(custom-definesandincludes)

ecm_optional_add_subdirectory(qmljs)

find_package(Clang 6.0)
set(clangSearchHint "")
if (NOT CLANG_FOUND)
    set(clangSearchHint "Please install a package providing libclang. Either pass -DLLVM_ROOT=/path/to/llvm-prefix or install the 'llvm-config' command-line utility for auto-detection.")
endif()
set_package_properties(Clang PROPERTIES
    DESCRIPTION "Clang libraries from the LLVM project. ${clangSearchHint}"
    PURPOSE "Used for KDevelop's C++/C support plugin."
    TYPE REQUIRED
)

if (CLANG_FOUND)
    if (NOT CLANG_CLANG_LIB)
        message(FATAL_ERROR "Could not find the Clang C library: libclang")
    endif()

    add_library(Clang::clang UNKNOWN IMPORTED)
    set_property(TARGET Clang::clang PROPERTY IMPORTED_LOCATION ${CLANG_CLANG_LIB})
    ecm_optional_add_subdirectory(clang)
endif()
# END: Languages

# BEGIN: Project builders
add_subdirectory(makebuilder)
add_subdirectory(ninjabuilder)
ecm_optional_add_subdirectory(cmakebuilder)
if (KDevelop-PG-Qt_FOUND)
    ecm_optional_add_subdirectory(qmakebuilder)
endif()
# END: Project builders

# BEGIN: Project managers
ecm_optional_add_subdirectory(cmake)
ecm_optional_add_subdirectory(custommake)
ecm_optional_add_subdirectory(custom-buildsystem)
add_subdirectory(meson)
if (KDevelop-PG-Qt_FOUND)
    ecm_optional_add_subdirectory(qmakemanager)
endif()
ecm_optional_add_subdirectory(genericprojectmanager)
# END: Project managers

# BEGIN: Runtimes
add_subdirectory(android)
if (UNIX)
    add_subdirectory(docker)
    add_subdirectory(flatpak)
endif()
# END: Runtimes

# BEGIN: VCS
ecm_optional_add_subdirectory(bazaar)
ecm_optional_add_subdirectory(git)
ecm_optional_add_subdirectory(perforce)

find_package(SubversionLibrary)
set_package_properties(SubversionLibrary PROPERTIES
    PURPOSE "Support for Subversion integration"
    URL "https://subversion.apache.org/"
    TYPE OPTIONAL)

if(SubversionLibrary_FOUND)
    ecm_optional_add_subdirectory(subversion)
endif()

add_subdirectory(vcschangesview)
# END: VCS

# BEGIN: Others
add_subdirectory(appwizard)
add_subdirectory(codeutils)
add_subdirectory(contextbrowser)
add_subdirectory(documentswitcher)
add_subdirectory(documentview)
add_subdirectory(execute)
add_subdirectory(executescript)
add_subdirectory(externalscript)
add_subdirectory(filemanager)
add_subdirectory(filetemplates)
add_subdirectory(grepview)
add_subdirectory(openwith)
add_subdirectory(outlineview)
add_subdirectory(patchreview)
add_subdirectory(problemreporter)
add_subdirectory(projectfilter)
add_subdirectory(projectmanagerview)
add_subdirectory(quickopen)
add_subdirectory(sourceformatter)
add_subdirectory(standardoutputview)
add_subdirectory(switchtobuddy)
add_subdirectory(testview)
add_subdirectory(scratchpad)
ecm_optional_add_subdirectory(classbrowser)
ecm_optional_add_subdirectory(executeplasmoid)
ecm_optional_add_subdirectory(ghprovider)
ecm_optional_add_subdirectory(konsole)
if (Qt5QuickWidgets_FOUND)
    add_subdirectory(welcomepage)
endif()

find_package(OktetaKastenControllers 0.3.1 CONFIG)
set_package_properties(OktetaKastenControllers PROPERTIES
    PURPOSE "Required for building Okteta KDevelop plugin."
    URL "https://kde.org/"
    TYPE OPTIONAL)
if (OktetaKastenControllers_FOUND)
    find_package(KastenControllers CONFIG)

    set_package_properties(KastenControllers PROPERTIES
        PURPOSE "Required for building Okteta KDevelop plugin."
        URL "https://kde.org/"
        TYPE OPTIONAL)
endif()
if (OktetaKastenControllers_FOUND AND KastenControllers_FOUND)
    add_subdirectory(okteta)
endif()
# END: Others

=== app/plasma/CMakeLists.txt ===
add_subdirectory(kdevelopsessionswatch)

add_subdirectory(applet)

find_package(KF5Runner CONFIG)
set_package_properties(KF5Runner PROPERTIES
    PURPOSE "Framework for Plasma runners. For enabling the KDevelop runner"
    URL "https://www.kde.org"
    TYPE OPTIONAL)
if(KF5Runner_FOUND)
    add_subdirectory(runner)
endif()

=== doc/kdevelop/CMakeLists.txt ===
########### install files ###############

kdoctools_create_handbook(index.docbook INSTALL_DESTINATION ${KDE_INSTALL_DOCBUNDLEDIR}/en SUBDIR kdevelop)

=== kdevplatform/tests/CMakeLists.txt ===
set(kdevtests_LIB_SRCS
    autotestshell.cpp
    kdevsignalspy.cpp
    testcore.cpp
    testproject.cpp
    testfile.cpp
    testlanguagecontroller.cpp
    testhelpers.cpp
    testplugincontroller.cpp
    testdebugsession.cpp
    testvariablecontroller.cpp
    testbreakpointcontroller.cpp
    testframestackmodel.cpp

    json/delayedoutput.cpp
    json/declarationvalidator.cpp
    json/testsuite.cpp
)
if(Qt5_VERSION VERSION_LESS "5.11.0")
    list(APPEND kdevtests_LIB_SRCS
        modeltest.cpp
    )
endif()

kdevplatform_add_library(KDevPlatformTests SOURCES ${kdevtests_LIB_SRCS})
target_link_libraries(KDevPlatformTests
PUBLIC
    KDev::Shell
    KDev::Language
    KDev::Project
    KDev::Debugger
PRIVATE
    Qt5::Test
)

install(FILES
    autotestshell.h
    kdevsignalspy.h
    testcore.h
    testproject.h
    testfile.h
    testlanguagecontroller.h
    testhelpers.h
    testplugincontroller.h
    testdebugsession.h
    testvariablecontroller.h
    testbreakpointcontroller.h
    testframestackmodel.h
    DESTINATION ${KDE_INSTALL_INCLUDEDIR}/kdevplatform/tests/
    COMPONENT Devel
)

install(FILES
    json/declarationvalidator.h
    json/delayedoutput.h
    json/jsontesthelpers.h
    json/testsuite.h
    json/testsuite.cpp
    json/jsondeclarationtests.h
    json/jsonducontexttests.h
    json/jsontypetests.h
    DESTINATION ${KDE_INSTALL_INCLUDEDIR}/kdevplatform/tests/json
    COMPONENT Devel
)

=== kdevplatform/util/CMakeLists.txt ===
add_definitions(-DTRANSLATION_DOMAIN=\"kdevplatform\")

########### next target ###############

set(KDevPlatformUtil_LIB_SRCS
    autoorientedsplitter.cpp
    filesystemhelpers.cpp
    foregroundlock.cpp
    formattinghelpers.cpp
    zoomcontroller.cpp
    kdevstringhandler.cpp
    focusedtreeview.cpp
    processlinemaker.cpp
    commandexecutor.cpp
    environmentselectionwidget.cpp
    environmentselectionmodel.cpp
    environmentprofilelist.cpp
    jobstatus.cpp
    activetooltip.cpp
    executecompositejob.cpp
    shellutils.cpp
    multilevellistview.cpp
    objectlist.cpp
    placeholderitemproxymodel.cpp
    projecttestjob.cpp
    widgetcolorizer.cpp
    path.cpp
    texteditorhelpers.cpp
    stack.cpp
    expandablelineedit.cpp
)

if(NOT WIN32)
    add_subdirectory(dbus_socket_transformer)
endif()

if(BUILD_TESTING)
    add_subdirectory(duchainify) # needs KDev::Tests
endif()

if(BUILD_TESTING)
    add_subdirectory(tests)
endif()

declare_qt_logging_category(KDevPlatformUtil_LIB_SRCS
    TYPE LIBRARY
    CATEGORY_BASENAME "util"
)

kdevplatform_add_library(KDevPlatformUtil SOURCES ${KDevPlatformUtil_LIB_SRCS})
target_link_libraries(KDevPlatformUtil
PUBLIC
    KDev::Interfaces
PRIVATE
    KF5::ItemModels
    KF5::GuiAddons
)
install( FILES kdevplatform_shell_environment.sh DESTINATION bin PERMISSIONS OWNER_EXECUTE OWNER_WRITE OWNER_READ GROUP_EXECUTE GROUP_READ WORLD_EXECUTE WORLD_READ)

add_executable(kdev_format_source kdevformatsource.cpp kdevformatfile.cpp)
ecm_mark_nongui_executable(kdev_format_source)
target_link_libraries(kdev_format_source Qt5::Core)
install(TARGETS kdev_format_source DESTINATION ${KDE_INSTALL_TARGETS_DEFAULT_ARGS})

install(FILES .zshrc PERMISSIONS OWNER_EXECUTE OWNER_WRITE OWNER_READ GROUP_EXECUTE GROUP_READ WORLD_EXECUTE WORLD_READ
        DESTINATION ${KDE_INSTALL_DATAROOTDIR}/kdevplatform/shellutils/)

########### install files ###############

install( FILES
    autoorientedsplitter.h
    filesystemhelpers.h
    foregroundlock.h
    formattinghelpers.h
    zoomcontroller.h
    wildcardhelpers.h
    kdevstringhandler.h
    ksharedobject.h
    focusedtreeview.h
    activetooltip.h
    processlinemaker.h
    commandexecutor.h
    environmentselectionwidget.h
    environmentprofilelist.h
    jobstatus.h
    pushvalue.h
    kdevvarlengtharray.h
    embeddedfreetree.h
    executecompositejob.h
    convenientfreelist.h
    multilevellistview.h
    objectlist.h
    placeholderitemproxymodel.h
    projecttestjob.h
    widgetcolorizer.h
    path.h
    stack.h
    texteditorhelpers.h
    ${CMAKE_CURRENT_BINARY_DIR}/utilexport.h
    DESTINATION ${KDE_INSTALL_INCLUDEDIR}/kdevplatform/util COMPONENT Devel)

=== plugins/android/CMakeLists.txt ===
add_definitions(-DTRANSLATION_DOMAIN=\"kdevandroid\")

declare_qt_logging_category(androidplugin_SRCS
    TYPE PLUGIN
    HEADER debug_android.h
    IDENTIFIER ANDROID
    CATEGORY_BASENAME "android"
)
qt5_add_resources(androidplugin_SRCS kdevandroidplugin.qrc)
ki18n_wrap_ui(androidplugin_SRCS androidpreferences.ui)
kconfig_add_kcfg_files(androidplugin_SRCS androidpreferencessettings.kcfgc)

kdevplatform_add_plugin(kdevandroid JSON kdevandroid.json SOURCES androidplugin.cpp androidruntime.cpp androidpreferences.cpp ${androidplugin_SRCS})
target_link_libraries(kdevandroid
    KF5::CoreAddons
    KDev::Interfaces
    KDev::Util
    KDev::OutputView
    KDev::Project
)

=== plugins/appwizard/CMakeLists.txt ===
add_definitions(-DTRANSLATION_DOMAIN=\"kdevappwizard\")

########### next target ###############

set(kdevappwizard_PART_SRCS
    appwizardplugin.cpp
    appwizarddialog.cpp
    appwizardpagewidget.cpp
    projectselectionpage.cpp
    projecttemplatesmodel.cpp
    projectvcspage.cpp
)

set(kdevappwizard_PART_UI
    projectselectionpage.ui
    projectvcspage.ui
)

declare_qt_logging_category(kdevappwizard_PART_SRCS
    TYPE PLUGIN
    IDENTIFIER PLUGIN_APPWIZARD
    CATEGORY_BASENAME "appwizard"
)

ki18n_wrap_ui(kdevappwizard_PART_SRCS ${kdevappwizard_PART_UI})

if(NOT KF5_VERSION VERSION_LESS "5.57.0")
install(FILES kdevappwizard.knsrc  DESTINATION ${KDE_INSTALL_KNSRCDIR})
else()
qt5_add_resources(kdevappwizard_PART_SRCS kdevappwizardknsrc.qrc)
endif()
qt5_add_resources(kdevappwizard_PART_SRCS kdevappwizard.qrc)
kdevplatform_add_plugin(kdevappwizard JSON kdevappwizard.json SOURCES ${kdevappwizard_PART_SRCS})

target_link_libraries(kdevappwizard
    KDev::Interfaces
    KDev::Vcs
    KDev::Language
    KDev::Sublime
    KDev::Util
    KF5::KIOWidgets
    KF5::NewStuff
    KF5::Archive
)

=== plugins/bazaar/CMakeLists.txt ===
add_definitions(-DTRANSLATION_DOMAIN=\"kdevbazaar\")

set(kdevbazaar_SRCS
    diffjob.cpp
    bzrannotatejob.cpp
    bazaarplugin.cpp
    bazaarpluginmetadata.cpp
    bazaarutils.cpp
    copyjob.cpp
)

kdevplatform_add_plugin(kdevbazaar JSON kdevbazaar.json SOURCES ${kdevbazaar_SRCS})

target_link_libraries(kdevbazaar
    KDev::Vcs
)

add_subdirectory(icons)
if(BUILD_TESTING)
    add_subdirectory(tests)
endif()

install(PROGRAMS org.kde.kdevelop_bzr.desktop DESTINATION ${KDE_INSTALL_APPDIR})

=== plugins/clang/CMakeLists.txt ===
add_definitions(-DTRANSLATION_DOMAIN=\"kdevclang\")
add_definitions(${LLVM_CFLAGS})
include_directories(${CLANG_INCLUDE_DIRS})

set(CMAKE_REQUIRED_LIBRARIES ${CMAKE_DL_LIBS})
check_cxx_source_compiles(
    "#include <dlfcn.h>\nint main() { Dl_info info; return dladdr(nullptr, &info); }"
    HAVE_DLFCN)

configure_file(
  "${CMAKE_CURRENT_SOURCE_DIR}/libclang_include_path.h.cmake"
  "${CMAKE_CURRENT_BINARY_DIR}/libclang_include_path.h"
  @ONLY
)

if(BUILD_TESTING)
    add_subdirectory(tests)
endif()

set(kdevclangprivate_SRCS
    clangsettings/clangsettingsmanager.cpp
    clangsettings/sessionsettings/sessionsettings.cpp

    codecompletion/completionhelper.cpp
    codecompletion/context.cpp
    codecompletion/includepathcompletioncontext.cpp
    codecompletion/model.cpp

    codegen/adaptsignatureaction.cpp
    codegen/adaptsignatureassistant.cpp
    codegen/codegenhelper.cpp
    codegen/clangrefactoring.cpp
    codegen/clangclasshelper.cpp
    codegen/sourcemanipulation.cpp

    duchain/builder.cpp
    duchain/clangdiagnosticevaluator.cpp
    duchain/clangducontext.cpp
    duchain/clanghelpers.cpp
    duchain/clangindex.cpp
    duchain/clangparsingenvironment.cpp
    duchain/clangparsingenvironmentfile.cpp
    duchain/clangpch.cpp
    duchain/clangproblem.cpp
    duchain/debugvisitor.cpp
    duchain/documentfinderhelpers.cpp
    duchain/duchainutils.cpp
    duchain/macrodefinition.cpp
    duchain/macronavigationcontext.cpp
    duchain/missingincludepathproblem.cpp
    duchain/navigationwidget.cpp
    duchain/parsesession.cpp
    duchain/todoextractor.cpp
    duchain/types/classspecializationtype.cpp
    duchain/unknowndeclarationproblem.cpp
    duchain/unsavedfile.cpp
    duchain/headerguardassistant.cpp

    util/clangdebug.cpp
    util/clangtypes.cpp
    util/clangutils.cpp
)
# dummy call to add the data to KDevelopCategories
# util/clangdebug.* cannot easily be generated with ecm_qt_declare_logging_category
# as the current code does not use Q_DECLARE_LOGGING_CATEGORY but instead
# has explicit code to tag KDEV_CLANG() as KDEVCLANGPRIVATE_EXPORT
# Keep in sync with util/clangdebug.*
declare_qt_logging_category(dummy_kdevclangprivate_SRCS
    TYPE PLUGIN
    HEADER dummy_debug.h
    IDENTIFIER KDEV_CLANG
    CATEGORY_BASENAME "clang"
    DESCRIPTION "clang-based language support"
)

include_directories(
    ${CMAKE_CURRENT_BINARY_DIR}
)

ki18n_wrap_ui(kdevclangprivate_SRCS
    clangsettings/sessionsettings/sessionsettings.ui
)

kconfig_add_kcfg_files(kdevclangprivate_SRCS clangsettings/sessionsettings/sessionconfig.kcfgc)

kdevelop_add_private_library(KDevClangPrivate SOURCES ${kdevclangprivate_SRCS})
target_link_libraries(KDevClangPrivate
PUBLIC
    KDev::Language
    KDev::Project
    KDev::Util
    Clang::clang
PRIVATE
    Qt5::Core
    KF5::TextEditor
    KF5::ThreadWeaver
    KDev::DefinesAndIncludesManager
    KDev::Util
    KDev::Sublime
)

if (HAVE_DLFCN)
    target_link_libraries(KDevClangPrivate PRIVATE ${CMAKE_DL_LIBS})
endif()

install(DIRECTORY duchain/wrappedQtHeaders DESTINATION ${KDE_INSTALL_DATADIR}/kdevclangsupport
        DIRECTORY_PERMISSIONS
            OWNER_READ OWNER_WRITE OWNER_EXECUTE
            GROUP_READ GROUP_WRITE GROUP_EXECUTE
            WORLD_READ WORLD_EXECUTE
        FILE_PERMISSIONS OWNER_READ GROUP_READ WORLD_READ)

set(kdevclangsupport_SRCS
    clangparsejob.cpp
    clangsupport.cpp
    clanghighlighting.cpp
)

qt5_add_resources(kdevclangsupport_SRCS kdevclangsupport.qrc)

kdevplatform_add_plugin(kdevclangsupport JSON kdevclangsupport.json SOURCES ${kdevclangsupport_SRCS})
target_link_libraries(kdevclangsupport
    KDevClangPrivate

    KF5::ThreadWeaver
    KF5::TextEditor
    KDev::Util
    KDev::Project
    KDev::DefinesAndIncludesManager
)

install(FILES kdevclang.xml DESTINATION ${KDE_INSTALL_MIMEDIR})
update_xdg_mimetypes(${KDE_INSTALL_MIMEDIR})

=== plugins/clangtidy/CMakeLists.txt ===
add_definitions(-DTRANSLATION_DOMAIN=\"kdevclangtidy\")

find_package(ClangTidy QUIET)
set_package_properties(ClangTidy PROPERTIES
    DESCRIPTION "A clang-based C++ “linter” tool"
    URL "https://clang.llvm.org/extra/clang-tidy/"
    TYPE RUNTIME
)

include_directories(
    ${Boost_INCLUDE_DIRS}
)

declare_qt_logging_category(kdevclangtidy_LOG_SRCS
    TYPE PLUGIN
    IDENTIFIER KDEV_CLANGTIDY
    CATEGORY_BASENAME "clangtidy"
)

set(kdevclangtidy_PART_SRCS
    ${kdevclangtidy_LOG_SRCS}

    analyzer.cpp
    job.cpp
    plugin.cpp
    checkset.cpp
    checksetselection.cpp
    checksetselectionlock.cpp
    checksetselectionmanager.cpp

    config/clangtidyprojectconfigpage.cpp
    config/clangtidypreferences.cpp
    config/checkselection.cpp
    config/checklistfilterproxysearchline.cpp
    config/checklistitemproxystyle.cpp
    config/checklistmodel.cpp
    config/checkgroup.cpp
    config/checksetselectioncombobox.cpp
    config/checksetselectionlistmodel.cpp
    config/checksetmanagewidget.cpp
    config/customchecksetconfigproxywidget.cpp

    parsers/clangtidyparser.cpp
# disable for now:
# CentOS used for appimage does not have string_ref.hpp (Boost >= 1.53) as used by current code
#     parsers/replacementparser.cpp
)

ki18n_wrap_ui(kdevclangtidy_PART_SRCS
    config/checksetmanagewidget.ui
    config/clangtidypreferences.ui
    config/clangtidyprojectconfigpage.ui
)

qt5_add_resources(kdevclangtidy_PART_SRCS
    kdevclangtidy.qrc
)

kconfig_add_kcfg_files(kdevclangtidy_PART_SRCS
    config/clangtidyconfig.kcfgc
    config/clangtidyprojectconfig.kcfgc
)

kdevplatform_add_plugin(kdevclangtidy
    JSON kdevclangtidy.json
    SOURCES ${kdevclangtidy_PART_SRCS}
)

target_link_libraries(kdevclangtidy
    KDevCompileAnalyzerCommon
    KDev::Interfaces
    KDev::Project
    KDev::Language
    KDev::OutputView
    KDev::Util
    KDev::Shell
    KF5::ItemViews
    KF5::ConfigCore
    KF5::I18n
)
if(Qt5_VERSION VERSION_LESS "5.10.0")
target_link_libraries(kdevclangtidy
    KF5::ItemModels
)
endif()

if(BUILD_TESTING)
    add_subdirectory(tests)
endif()

=== plugins/classbrowser/CMakeLists.txt ===
add_definitions(-DTRANSLATION_DOMAIN=\"kdevclassbrowser\")
include_directories(
    ${Boost_INCLUDE_DIRS}
)

# workaround a boost bug in 1.37 and 1.38 that causes link failure when exceptions are disabled
# see https://svn.boost.org/trac/boost/ticket/2947 for details
if( ${Boost_MAJOR_VERSION}.${Boost_MINOR_VERSION}.${Boost_PATCH_VERSION} VERSION_GREATER 1.36.1 )
    kde_enable_exceptions()
endif()

set(kdevclassbrowser_PART_SRCS
    classbrowserplugin.cpp
    classwidget.cpp
    classtree.cpp
)
declare_qt_logging_category(kdevclassbrowser_PART_SRCS
    TYPE PLUGIN
    IDENTIFIER PLUGIN_CLASSBROWSER
    CATEGORY_BASENAME "classbrowser"
)
qt5_add_resources(kdevclassbrowser_PART_SRCS kdevclassbrowser.qrc)
kdevplatform_add_plugin(kdevclassbrowser JSON kdevclassbrowser.json SOURCES ${kdevclassbrowser_PART_SRCS})
target_link_libraries(kdevclassbrowser KF5::TextEditor KDev::Util KDev::Language KDev::Interfaces)

=== debian/changelog ===
kdevelop (4:5.6.2-4) unstable; urgency=medium

  * Team upload.
  * Backport upstream commit 4688d626c145711e35f3676dbd4c827b3b2ea7f6 to fix
    the detection of the clang version from its version string; patch
    upstream_Fix-test_codecompletion-test_duchain-clang-test_prob.patch.

 -- Pino Toscano <pino@debian.org>  Wed, 10 Feb 2021 14:01:07 +0100

kdevelop (4:5.6.2-3) unstable; urgency=medium

  * Team upload.
  * Remove extra quoting for clang architectures.

 -- Pino Toscano <pino@debian.org>  Tue, 09 Feb 2021 13:01:52 +0100

kdevelop (4:5.6.2-2) unstable; urgency=medium

  * Team upload.
  * Generate a clang dependency only on architectures that use clang.

 -- Pino Toscano <pino@debian.org>  Tue, 09 Feb 2021 12:17:45 +0100

kdevelop (4:5.6.2-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.
  * Use execute_after_dh_auto_install to avoid invoking dh_auto_install
    manually.
  * Require the same version of the clang-N used for the build: this is because
    kdevelop hardcodes the clang version and its include path, so we should not
    let an older clang than the build one be usable.

 -- Pino Toscano <pino@debian.org>  Wed, 03 Feb 2021 10:19:20 +0100

kdevelop (4:5.6.1-1) unstable; urgency=medium

  * Team upload.
  * New upstream release:
    - improves the detection of the GDB version (Closes: #975337)
  * Remove the upstream GPG signing key, as it changed and I cannot find the
    new one publically.
  * Bump Standards-Version to 4.5.1, no changes required.
  * Move the creation of /usr/share/kdevclangsupport from a dh_install override
    to a dh_auto_install one, where it is more logic to do.
  * Do not ship /usr/share/kdevqmljssupport/propertywidgets/README, as it is
    useful only in the sources.
  * Switch the watch file to version 4, no changes required.

 -- Pino Toscano <pino@debian.org>  Wed, 09 Dec 2020 10:12:48 +0100

kdevelop (4:5.6.0-3) unstable; urgency=medium

  * Team upload.
  * Adapt to krunner 5.72.0: (Closes: #972848)
    - stop installing file no more needed for it
    - bump libkf5runner-dev build dependency
  * Fix day-of-week for changelog entries 4:3.1.2-4, 4:3.1.2-3, 4:3.1.0-3,
    1:2.999-0cvs20030905, 1:2.999-0cvs20030815, 1:2.999-1.
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    Repository-Browse.
  * Update lintian overrides.

 -- Pino Toscano <pino@debian.org>  Sun, 25 Oct 2020 08:23:16 +0100

kdevelop (4:5.6.0-2) unstable; urgency=medium

  * Team upload.
  * Upload to unstable.

 -- Pino Toscano <pino@debian.org>  Fri, 11 Sep 2020 16:31:00 +0200

kdevelop (4:5.6.0-1) experimental; urgency=medium

  * Team upload.
  * New upstream release.
  * Add the upstream GPG signing key.
  * Update the build dependencies according to the upstream build system:
    - bump Qt packages to 5.8.0
    - bump KF packages to 5.50.0
  * Rename packages according to the SONAME bumps:
    - kdevelop55-libs -> kdevelop56-libs
  * Update install files.
  * Bump KDEV_PLUGIN_VERSION to 34, according to upstream.
  * Bump the debhelper compatibility to 13:
    - switch the debhelper-compat build dependency to 13
    - stop passing --fail-missing to dh_missing, as it is the default behaviour
  * Update lintian overrides.

 -- Pino Toscano <pino@debian.org>  Tue, 08 Sep 2020 22:25:19 +0200

=== debian/control ===
Source: kdevelop
Section: devel
Priority: optional
Maintainer: Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
Uploaders: Jeremy Lainé <jeremy.laine@m4x.org>,
           George Kiagiadakis <kiagiadakis.george@gmail.com>,
           Andreas Cord-Landwehr <cola@uni-paderborn.de>
Build-Depends: bash-completion,
               clang (>= 1:6.0) [!alpha !hppa !ia64 !kfreebsd-any !m68k !sh4 !x32],
               cmake (>= 2.8.12),
               debhelper-compat (= 13),
               dh-exec,
               extra-cmake-modules (>= 5.59.0~),
               gettext,
               kdevelop-pg-qt (>= 2.2.0),
               libboost-serialization-dev,
               libastyle-dev (>= 3.1),
               libclang-dev (>= 1:6.0) [!alpha !hppa !ia64 !kfreebsd-any !m68k !sh4 !x32],
               libgrantlee5-dev,
               libkf5archive-dev (>= 5.50.0~),
               libkf5config-dev (>= 5.50.0~),
               libkf5crash-dev (>= 5.50.0~),
               libkf5declarative-dev (>= 5.50.0~),
               libkf5doctools-dev (>= 5.50.0~),
               libkf5guiaddons-dev (>= 5.50.0~),
               libkf5i18n-dev (>= 5.50.0~),
               libkf5iconthemes-dev (>= 5.50.0~),
               libkf5itemmodels-dev (>= 5.50.0~),
               libkf5itemviews-dev (>= 5.50.0~),
               libkf5jobwidgets-dev (>= 5.50.0~),
               libkf5kcmutils-dev (>= 5.50.0~),
               libkf5kio-dev (>= 5.50.0~),
               libkf5newstuff-dev (>= 5.50.0~),
               libkf5notifications-dev (>= 5.50.0~),
               libkf5notifyconfig-dev (>= 5.50.0~),
               libkf5parts-dev (>= 5.50.0~),
               libkf5plasma-dev [linux-any],
               libkf5purpose-dev (>= 5.44.0),
               libkf5runner-dev (>= 5.72.0~) [linux-any],
               libkf5service-dev (>= 5.50.0~),
               libkf5sonnet-dev (>= 5.50.0~),
               libkf5sysguard-dev,
               libkf5texteditor-dev (>= 5.50.0~),
               libkf5threadweaver-dev (>= 5.50.0~),
               libkf5widgetsaddons-dev (>= 5.50.0~),
               libkf5windowsystem-dev (>= 5.50.0~),
               libkf5xmlgui-dev (>= 5.50.0~),
               libkomparediff2-dev,
               libqt5webkit5-dev (>= 5.7.0),
               libsvn-dev,
               llvm-dev (>= 1:6.0) [!alpha !hppa !ia64 !kfreebsd-any !m68k !sh4 !x32],
               okteta-dev (>= 5:0.26.2~),
               pkg-config,
               pkg-kde-tools (>= 0.15.16),
               qtbase5-dev (>= 5.8.0~),
               qtdeclarative5-dev (>= 5.8.0~),
               qttools5-dev,
               qttools5-dev-tools,
               shared-mime-info
Standards-Version: 4.5.1
Rules-Requires-Root: no
Homepage: https://www.kdevelop.org/
Vcs-Browser: https://salsa.debian.org/qt-kde-team/extras/kdevelop
Vcs-Git: https://salsa.debian.org/qt-kde-team/extras/kdevelop.git

Package: kdevelop56-libs
Section: libs
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: shared libraries for the KDevelop platform
 This package contains shared libraries needed to run integrated development
 environments based on the KDevelop platform.
 .
 This package is part of the KDevelop platform.

Package: kdevelop
Architecture: any
Depends: kdevelop-data (>= ${source:Version}),
         kdevelop56-libs (= ${binary:Version}),
         kinit,
         qml-module-qtquick-controls,
         qml-module-qtquick-layouts,
         qml-module-qtquick-window2,
         qml-module-qtquick-xmllistmodel,
         qml-module-qtquick2,
         qml-module-qtwebkit,
         ${misc:Depends},
         ${shlibs:Depends}
Recommends: ${kdevelop:clang}, g++, gcc, gdb (>= 7.0), kapptemplate, kio-extras, make
Suggests: clang,
          clang-tidy,
          clazy,
          cmake,
          cppcheck,
          git,
          heaptrack [linux-any],
          kdevelop-l10n,
          konsole,
          meson,
          ninja-build
Breaks: kdevplatform10-libs (<< 5.2)
Replaces: kdevplatform10-libs (<< 5.2)
Description: integrated development environment for C/C++ and other languages
 KDevelop is a Free and Open Source integrated development
 environment (IDE). It provides editing, navigation and debugging features for
 several programming languages, as well as integration with multiple build
 systems and version-control systems, using a plugin-based architecture.
 .
 KDevelop has parser backends for C, C++ and Javascript/QML, with further
 external plugins supporting e.g. PHP or Python.

Package: kdevelop-data
Architecture: all
Depends: ${misc:Depends}
Breaks: kdevplatform10-libs (<< 5.2)
Replaces: kdevplatform10-libs (<< 5.2)
Description: data files for the KDevelop IDE
 KDevelop is a Free and Open Source integrated development
 environment (IDE). It provides editing, navigation and debugging features for
 several programming languages, as well as integration with multiple build
 systems and version-control systems, using a plugin-based architecture.
 .
 This package contains arch independent data for KDevelop.

Package: kdevelop-dev
Section: libdevel
Architecture: any
Depends: kdevelop56-libs (= ${binary:Version}),
         libgrantlee5-dev,
         libkf5archive-dev (>= 5.50.0~),
         libkf5config-dev (>= 5.50.0~),
         libkf5guiaddons-dev (>= 5.50.0~),
         libkf5i18n-dev (>= 5.50.0~),
         libkf5iconthemes-dev (>= 5.50.0~),
         libkf5itemmodels-dev (>= 5.50.0~),
         libkf5itemviews-dev (>= 5.50.0~),
         libkf5jobwidgets-dev (>= 5.50.0~),
         libkf5kcmutils-dev (>= 5.50.0~),
         libkf5kio-dev (>= 5.50.0~),
         libkf5newstuff-dev (>= 5.50.0~),
         libkf5notifications-dev (>= 5.50.0~),
         libkf5notifyconfig-dev (>= 5.50.0~),
         libkf5parts-dev (>= 5.50.0~),
         libkf5service-dev (>= 5.50.0~),
         libkf5texteditor-dev (>= 5.50.0~),
         libkf5threadweaver-dev (>= 5.50.0~),
         libkf5windowsystem-dev (>= 5.50.0~),
         qtbase5-dev (>= 5.7.0),
         qtdeclarative5-dev (>= 5.7.0),
         ${misc:Depends}
Breaks: kdevplatform-dev (<< 5.2)
Replaces: kdevplatform-dev (<< 5.2)
Description: development files for the KDevelop IDE
 KDevelop is a Free and Open Source integrated development
 environment (IDE). It provides editing, navigation and debugging features for
 several programming languages, as well as integration with multiple build
 systems and version-control systems, using a plugin-based architecture.
 .
 This package contains development files for KDevelop.

Package: kdevelop-l10n
Section: localization
Architecture: all
Depends: ${misc:Depends}
Replaces: kdevplatform-l10n (<< 5.2)
Breaks: kdevplatform-l10n (<< 5.2)
Description: localization files for the KDevelop IDE
 KDevelop is a Free and Open Source integrated development
 environment (IDE). It provides editing, navigation and debugging features for
 several programming languages, as well as integration with multiple build
 systems and version-control systems, using a plugin-based architecture.
 .
 This package contains the translations for KDevelop.

Package: plasma-kdevelop
Architecture: linux-any
Depends: kdevelop (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
Description: KDevelop plugins for Plasma
 KDevelop is a Free and Open Source integrated development
 environment (IDE). It provides editing, navigation and debugging features for
 several programming languages, as well as integration with multiple build
 systems and version-control systems, using a plugin-based architecture.
 .
 This package contains the KDevelop plugins for integrating in the Plasma
 desktop environment:
  * sessions data engine
  * sessions widget
  * sessions KRunner module

Package: kdevplatform-dev
Section: oldlibs
Architecture: all
Depends: kdevelop-dev (>= ${source:Version}), ${misc:Depends}
Description: transitional package for kdevelop-dev
 This package is a transitional package, to upgrade to kdevelop-dev.
 It can be safely removed after the upgrade.
 .
 This package is part of the KDevelop platform.

Package: kdevplatform-l10n
Section: oldlibs
Architecture: all
Depends: kdevelop-l10n (>= ${source:Version}), ${misc:Depends}
Description: transitional package for kdevelop-l10n
 This package is a transitional package, to upgrade to kdevelop-l10n.
 It can be safely removed after the upgrade.
 .
 This package is part of the KDevelop platform.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/architecture.mk

export DEB_LDFLAGS_MAINT_APPEND := -Wl,--as-needed

# from the top-level CMakeLists.txt
export KDEV_PLUGIN_VERSION=34

# The list of architectures (expanded, without wildcards) that do not use clang
no_clang_args = alpha hppa ia64 kfreebsd-amd64 kfreebsd-i386 m68k sh4 x32
ifeq (,$(filter $(DEB_HOST_ARCH), $(no_clang_args)))
# The clang-N used for the build by the unversioned clang
current_clang_pkg = $(shell dpkg -S "$(shell realpath $(shell env PATH=$$(echo "$$PATH" | sed -r -e 's|/usr/lib/ccache/?:||') which clang))" | cut -d: -f1)
# The upstream version of a package passed as parameter
upstream_version_of_pkg = $(shell dpkg-query -f '$${Version}' -W $(1) | sed -e 's/-[^-]*$$//')
# The clang dependency string
clang_dependency = $(current_clang_pkg) (>= $(call upstream_version_of_pkg,$(current_clang_pkg))~)
else
clang_dependency =
endif

%:
	dh $@ --with kf5

override_dh_auto_configure:
	dh_auto_configure -Skf5 -- -DBUILD_TESTING=OFF

execute_after_dh_auto_install:
	# create this directory if not existing, so kdevelop-data.install
	# is the same, no matter whether clang is built
	mkdir -p debian/tmp/usr/share/kdevclangsupport/
	# not useful source documentation
	rm debian/tmp/usr/share/kdevqmljssupport/propertywidgets/README

override_dh_gencontrol:
	dh_gencontrol -- -V'kdevelop:clang=$(clang_dependency)'

.PHONY: override_dh_auto_test

=== debian/watch ===
version=4
https://download.kde.org/stable/kdevelop/([\d.]+)/src/kdevelop-([\d.]+)\.tar\.xz
